    PrefabFiles = 
{
    "flower_cave",
    "lightbulb",
}

    Assets = {}

local GROUND = GLOBAL.GROUND
local GetGroundTypeAtPosition = GLOBAL.GetGroundTypeAtPosition
local distsq = GLOBAL.distsq
local Vector3 = GLOBAL.Vector3
local SpawnPrefab = GLOBAL.SpawnPrefab

local defaultTileSet = 
{
    GROUND.ROCKY,
    GROUND.ROAD,
    GROUND.IMPASSABLE,
    GROUND.UNDERROCK,
    GROUND.WOODFLOOR,
    GROUND.CARPET,
    GROUND.CHECKER,
}

local plantables = 
{
    {plant = "lightbulb", invalidTurf = defaultTileSet, sounds = {"dontstarve/wilson/pickup_reeds"},
    altSpawn = function()
    local randomnumber = math.random()
    if randomnumber > 1/3 then
    return "flower_cave"
    elseif 
    (randomnumber < 1/3) and (randomnumber > 0.1) then
    return "flower_cave_double"
    else
    return "flower_cave_triple"
    end
end,
    deployExtras = function(inst, pt, deployer, flower)
    flower.components.pickable:OnTransplant()
end}
}

local lightflowersdata = 
{
    {name = "flower_cave", bulbs = 1},
    {name = "flower_cave_double", bulbs = 2},
    {name = "flower_cave_triple", bulbs = 3},
}

for k,v in pairs(lightflowersdata) do 
    function PostInit_lightflowers(inst)
    local function ontransplantfn(inst)
    inst.components.pickable:MakeEmpty()
end
    inst.components.pickable.ontransplantfn = ontransplantfn

local function dig_up(inst, chopper)
    if inst.components.pickable and inst.components.pickable:CanBePicked() then
    for i=1,v.bulbs do
    inst.components.lootdropper:SpawnLootPrefab("lightbulb")
end
    inst:Remove()
    local bush = inst.components.lootdropper:SpawnLootPrefab("foliage")
    end
end
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(GLOBAL.ACTIONS.DIG)
    inst.components.workable:SetOnFinishCallback(dig_up)
    inst.components.workable:SetWorkLeft(1)
end
AddPrefabPostInit(v.name, PostInit_lightflowers)
end

for i,v in ipairs(plantables) do
    AddPrefabPostInit(v.plant, function(inst)
    local function test_turf(inst, tiletype)
    if v.validTurf then
    for i,turf in ipairs(v.validTurf) do
    if tiletype == turf then
    return true
    end
end
    return false
end
    if v.invalidTurf then
    for i,turf in ipairs(v.invalidTurf) do
    if tiletype == turf then
    return false
    end
end
    return true
end
    return true
end

local function test_ground(inst, pt)
    if v.turfExtras then
    if not v.turfExtras() then
    return false
    end
end
    local tiletype = GetGroundTypeAtPosition(pt)
    local ground_OK = test_turf(inst, tiletype) and tiletype < GROUND.UNDERGROUND
    if ground_OK then
    local notags = {'NOBLOCK', 'player', 'FX'}
    local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 4, nil, notags)
    local min_spacing = inst.components.deployable.min_spacing or 2
        for k, v in pairs(ents) do
    if v ~= inst and v.entity:IsValid() and v.entity:IsVisible()
    and not v.components.placer and v.parent == nil then
    if distsq( Vector3(v.Transform:GetWorldPosition()), pt) < min_spacing*min_spacing then
    return false
        end
    end
end
    return true
end
    return false
end

local function CanDeploy(inst) return true end
local function OnDeploy(inst, pt, deployer) 
    local flower = SpawnPrefab(v.spawn or v.altSpawn())
    if flower then
    flower.Transform:SetPosition(pt.x, pt.y, pt.z)
    inst.components.stackable:Get():Remove()
    if v.deployExtras then
    v.deployExtras(inst, pt, deployer, flower)
end
    if v.sounds then
    if not flower.SoundEmitter then
    flower.entity:AddSoundEmitter()
end
    for i,sound in ipairs(v.sounds) do
    flower.SoundEmitter:PlaySound(sound)
            end
        end
    end
end
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = OnDeploy
    inst.components.deployable.test = test_ground
    if v.spacing then 
    inst.components.deployable.min_spacing = v.spacing
        end
    end)
end